use std::{ops::Deref, sync::Arc};

#[derive(Clone)]
pub struct SharedApp(Arc<App>);

impl Deref for SharedApp {
    type Target = Arc<App>;

    fn deref(&self) -> &Self::Target {
        &self.0
    }
}

impl Default for SharedApp {
    fn default() -> Self {
        Self::new()
    }
}

impl SharedApp {
    pub fn new() -> Self {
        Self(Arc::new(App::new()))
    }
}

pub struct App {}

impl Default for App {
    fn default() -> Self {
        Self::new()
    }
}

impl App {
    pub fn new() -> Self {
        Self {}
    }
}
